import logging

# Configure logging
logging.basicConfig(level=logging.INFO, format="%(asctime)s - %(name)s - %(levelname)s - %(message)s")
logger = logging.getLogger(__name__)

llm = None

{% if model_platform == "GenAI-LLM-Hosting" %}
from genai import GenAI
from genai.langchain import LLM, LLM_t2tGen
import os

client = GenAI(
    os.getenv("IAIS_GENAI_USERNAME"),
    os.getenv("IAIS_GENAI_PASSWORD"),
    url="https://genai.iais.fraunhofer.de",
)

if '{{ modality }}' == "T2T":
    logger.info("Initializing LLM for Text-to-Text (T2T) mode.")
    llm = LLM(client=client, model='{{ model_name }}')
elif '{{ modality }}' == "T2TGEN":
    logger.info("Initializing LLM for Text-to-Text Generation (T2TGEN) mode.")
    llm = LLM_t2tGen(client=client, model='{{ model_name }}')
else:
    logger.error("Error invoking LLM: Unsupported modality.")

{% elif model_platform == "Individual-OpenAI" %}
from langchain_openai import OpenAI, ChatOpenAI
import os

os.environ["OPENAI_API_KEY"] = os.getenv("OPENAI_API_KEY")
os.environ["OPENAI_ORG_ID"] = os.getenv("OPENAI_ORG_ID")

logger.info("Initializing OpenAI Chat model.")
llm = ChatOpenAI(
    model="{{ model_name }}"
)

{% elif model_platform == "IONOS-DGX" %}

from ionos_llm import DGX_LLM

logger.info("Initializing DGX LLM model.")
llm = DGX_LLM(model_name="{{ model_name }}")

{% endif %}